LeetCode34:在排序数组中查找元素第一个和最后一个位置

原题地址:. - 力扣(LeetCode)

题目描述

给你一个按照非递减顺序排列的整数数组 nums,和一个目标值 target。请你找出给定目标值在数组中的开始位置和结束位置。

如果数组中不存在目标值 target,返回 [-1, -1]。

你必须设计并实现时间复杂度为 O(log n) 的算法解决此问题。

示例 1:

复制代码
输入:nums = [5,7,7,8,8,10], target = 8
输出:[3,4]

示例 2:

复制代码
输入:nums = [5,7,7,8,8,10], target = 6
输出:[-1,-1]

示例 3:

复制代码
输入:nums = [], target = 0
输出:[-1,-1]

提示:

  • 0 <= nums.length <= 105
  • -109 <= nums[i] <= 109
  • nums 是一个非递减数组
  • -109 <= target <= 109

解题思路

  • 二分查找:我们使用二分查找来查找目标值的左边界和右边界。在给定的有序数组中,使用二分查找可以减少搜索范围,从而达到 O(log n) 的时间复杂度。

    • 左边界查找 :我们在二分查找时,使用一个标志 lower 来指示我们是查找目标值的左边界还是右边界。
      • 如果 lower 为 true,则我们会在目标值的位置停止时继续往左移动,从而找到目标值的最左边位置。
      • 如果 lower 为 false,则我们会在目标值的位置停止时继续往右移动,直到目标值的右边界。
  • 返回结果 :通过两次二分查找分别获取左边界和右边界的索引。如果左边界小于等于右边界,并且这两个位置上的值都等于目标值,则返回这两个索引;否则,返回 [-1, -1]。

源码实现

java 复制代码
class Solution {
    public int[] searchRange(int[] nums, int target) {
        // 1. 使用二分查找找到目标值的左边界(lower = true)
        int leftIdx = binarySearch(nums, target, true);
        // 2. 使用二分查找找到目标值的右边界(lower = false),然后减去 1 获取实际的右边界
        int rightIdx = binarySearch(nums, target, false) - 1;

        // 3. 检查左边界和右边界是否有效,且这两个位置上的值是否为目标值
        if (leftIdx <= rightIdx && rightIdx < nums.length && nums[leftIdx] == target && nums[rightIdx] == target) {
            // 4. 返回目标值的左边界和右边界
            return new int[]{leftIdx, rightIdx};
        } 
        // 5. 如果目标值不存在,返回 [-1, -1]
        return new int[]{-1, -1};
    }

    // 这里的 lower 参数用于控制是查找左边界(true)还是右边界(false)
    public int binarySearch(int[] nums, int target, boolean lower) {
        // 1. 初始化二分查找的左右边界
        int left = 0, right = nums.length - 1;
        // 2. 默认返回的答案是 nums.length,这样当目标值不存在时,能保证返回 [-1, -1]
        int ans = nums.length;

        while (left <= right) {
            int mid = (left + right) / 2;
            
            // 3. 根据目标值与中间值的比较来更新搜索范围
            // 4. 如果目标值小于中间值,或者是查找左边界时(lower = true)中间值大于等于目标值,
            // 则将搜索范围缩小到左半部分
            if (nums[mid] > target || (lower && nums[mid] >= target)) {
                right = mid - 1;
                ans = mid;
            } else {
                // 5. 如果目标值大于中间值,则搜索范围缩小到右半部分
                left = mid + 1;
            }
        }
        
        // 6. 返回找到的索引位置(若没有找到,则返回 nums.length)
        return ans;
    }
}

复杂度分析

  • 时间复杂度:

    • 每次调用 binarySearch 都是 O(log n),其中 n 是数组的长度。
    • 在 searchRange 方法中,调用了两次 binarySearch,一次查找左边界,另一次查找右边界。因此总时间复杂度为 O(log n)。
  • 空间复杂度:

    • 该算法只使用了常量级的额外空间(除了返回结果数组),因此空间复杂度是 O(1)。
相关推荐
代码什么用18 分钟前
Spring基础使用
java·后端·spring
信奥卷王39 分钟前
[GESP202609 六级] 分树规划
算法
Su米苏41 分钟前
Spring AI 中MCP 与普通 @Tool的区别
java·人工智能·spring
夏幻灵1 小时前
LeetCode 21:合并两个有序链表——双指针与哑节点详解
算法·leetcode·链表
码云数智-园园1 小时前
unique_ptr 还是 shared_ptr?C++ 智能指针选型与内存泄漏实战分析
java·开发语言
老板一杯拿铁1 小时前
Java 异常体系详解:从字节码原理到最佳实践
java
蜗牛互联网1 小时前
Java 17 HttpClient调用文件转写API的超时与失败回退
java·人工智能·后端
禾小西2 小时前
07丨Redis 哨兵机制:主库故障后,如何恢复服务?
java·开发语言·redis
我不是阵雨2 小时前
JDK 21虚拟线程Pinning陷阱:一文拔钉解困
java·开发语言